// Written by: Mohamed Soliman
// This code is for controlling servo motor with IR remote control
// When clicking at any of two buttons the motor is toggling between the rotation and stop

#include <IRremote.h>      //must copy IRremote library to arduino libraries
#include <Servo.h>
#define right 0x449E79F   //clockwise rotation button
#define left 0x8C22657B  //counter clockwise rotation button

int RECV_PIN = 2;       //IR receiver pin
Servo servo;
int val;                //rotation angle
bool cwRotation, ccwRotation;  //the states of rotation

IRrecv irrecv(RECV_PIN);

decode_results results;


// ================
// ===   SETUP  ===
// ================

void setup()
   {
    Serial.begin(9600);
    irrecv.enableIRIn(); // Start the receiver
    servo.attach(9);     //servo pin
   }


// ===============
// ===   LOOP  ===
// ===============

void loop() 
   {
    if (irrecv.decode(&results))
       {
        Serial.println(results.value, HEX);
        irrecv.resume(); // Receive the next value

        if (results.value == right)
           {
            cwRotation = !cwRotation;      //toggle the rotation value
            ccwRotation = false;         //no rotation in this direction
           }

        if (results.value == left)
           {
            ccwRotation = !ccwRotation;   //toggle the rotation value
            cwRotation = false;            //no rotation in this direction
           }
       }

    //Serial.print("cwRotation = ");
    //Serial.println(cwRotation);

     
    if (cwRotation && (val != 1))
       {
        val--;                         //for colockwise button

        servo.write(val);
        delay(20);          //General speed
       }
       
    if (ccwRotation && (val != 170))
       {
        val++;                         //for counter colockwise button

        servo.write(val);
        delay(20);          //General speed
       }  
    
   }
